# Class VulkanExtent2D.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanExtent2D.Builder

Enclosing class:
  `VulkanExtent2D`

public static final class VulkanExtent2D.Builder extends Object
Builds instances of type `VulkanExtent2D`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanExtent2D`
  `build()`
  Builds a new `VulkanExtent2D`.
  `final VulkanExtent2D.Builder`
  `from(VulkanExtent2DType instance)`
  Fill a builder with attribute values from the provided `VulkanExtent2DType` instance.
  `final VulkanExtent2D.Builder`
  `setHeight(int height)`
  Initializes the value for the `height` attribute.
  `final VulkanExtent2D.Builder`
  `setWidth(int width)`
  Initializes the value for the `width` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanExtent2D.Builder from(VulkanExtent2DType instance)
    Fill a builder with attribute values from the provided `VulkanExtent2DType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setWidth

    public final VulkanExtent2D.Builder setWidth(int width)
    Initializes the value for the `width` attribute.
    Parameters:
      `width` - The value for width
    Returns:
      `this` builder for use in a chained invocation

  - ### setHeight

    public final VulkanExtent2D.Builder setHeight(int height)
    Initializes the value for the `height` attribute.
    Parameters:
      `height` - The value for height
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanExtent2D build()
    Builds a new `VulkanExtent2D`.
    Returns:
      An immutable instance of VulkanExtent2D
    Throws:
      `IllegalStateException` - if any required attributes are missing